#include <stdio.h> 

/* maximum result size that we ever expect to get */
#define MAXB 1024

extern int debug;

/* getline reads lines from the socket. We expect short */
/* results here and they will generally be satisfied by a single */
/* read(). However, we cannot count on this so we have to loop */
/* until we get that terminating \n */
/* this is pretty much a generic set of routines for buffered input */

char *
getline(char *buf, int max, int fd)
{
	int i, c;
	for (i=0; i < max; ) {
		if ((c = getch(fd)) < 0)
			break;
		else if (c == '\r')
			/* ignore cr from telnet and windows stuff */
			continue;
		else if (c == '\n')
			break;
		else
			buf[i++] = c;
	}
	if (c < 0)
		return 0;
	buf[i] = 0;
	return buf;
}


char inbuf[MAXB];
char *bp;
int where=0;
int end=0;
int eof = 0;

int getch(int fd)
{
	if (eof) return -1;
	if (where == end) {	// refill the buffer
		end = read(fd, inbuf, MAXB);
		where = 0;
		if (end <= 0) {
			eof == 1;
			return -1;
		}
	}
	return inbuf[where++];
}
